{% extends "base.html" %}{% load static i18n %}

{% block javascript %}
{{ block.super }}
  <script defer src="{% static 'js/html5-qrcode.js' %}"></script>
{% endblock javascript %}

{% block content %}
  <div class="row">
    <div class="col-10">
      <h1>{% translate 'Scan any barcode' %}</h1>
    </div>
    <div class="col-2 float-end">
      <a href="{% url 'home' %}" class="h1 float-end"><i class="bi-x-lg"></i></a>
    </div>
  </div>
  <div class="row">
    <div class="col">
      <div id="reader"></div>
    </div>
  </div>
  <div class="row mt-4">
    <div class="col">
      <a href="{% url 'barcodes:set' "mobile" %}?parent_id={{ request.GET.parent_id }}&option={{ request.GET.option }}" class="btn btn-outline-primary">{% translate 'Scan with the camera' %}</a>
      <a href="{% url 'barcodes:set' "reader" %}?parent_id={{ request.GET.parent_id }}&option={{ request.GET.option }}" class="btn btn-primary">{% translate 'Scan with a reader' %}</a>
    </div>
  </div>
{% endblock content %}

{% block inline_javascript %}
<script>
  function onScanSuccess(decodedText, decodedResult) {
    const base_url = '{% url 'barcodes:search' %}';
    var parent_id = '{{ request.GET.parent_id }}'
    var option = '{{ request.GET.option }}'
    location.replace(base_url + '?barcode=' + decodedText + '&parent_id=' + parent_id + '&option=' + option);
    console.log(`Code matched = ${decodedText}`, decodedResult);
  }

  function onScanFailure(error) {
    // handle scan failure, usually better to ignore and keep scanning.
    // for example:
    console.warn(`Code scan error = ${error}`);
  }

  let qrboxFunction = function(viewfinderWidth, viewfinderHeight) {
      let minEdgePercentage = 0.7; // 70%
      let minEdgeSize = Math.min(viewfinderWidth, viewfinderHeight);
      let qrboxSize = Math.floor(minEdgeSize * minEdgePercentage);
      return {
          width: qrboxSize,
          height: qrboxSize
      };
  }


  window.addEventListener('DOMContentLoaded', () => {
    let html5QrcodeScanner = new Html5QrcodeScanner(
    "reader",
    { fps: 10, qrbox: qrboxFunction,
      rememberLastUsedCamera: true,
      // Only support camera scan type.
      supportedScanTypes: [Html5QrcodeScanType.SCAN_TYPE_CAMERA],
      showTorchButtonIfSupported: true},
    /* verbose= */ false);

    html5QrcodeScanner.render(onScanSuccess, onScanFailure);
  });

</script>
{% endblock %}
